#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ProcedureEventOrigin {
    #[serde(rename = "procedureExecutionRid")]
    procedure_execution_rid: conjure_object::ResourceIdentifier,
    #[serde(rename = "procedureRid")]
    procedure_rid: conjure_object::ResourceIdentifier,
    #[builder(into)]
    #[serde(rename = "stepId")]
    step_id: String,
}
impl ProcedureEventOrigin {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        procedure_execution_rid: conjure_object::ResourceIdentifier,
        procedure_rid: conjure_object::ResourceIdentifier,
        step_id: impl Into<String>,
    ) -> Self {
        Self::builder()
            .procedure_execution_rid(procedure_execution_rid)
            .procedure_rid(procedure_rid)
            .step_id(step_id)
            .build()
    }
    #[inline]
    pub fn procedure_execution_rid(&self) -> &conjure_object::ResourceIdentifier {
        &self.procedure_execution_rid
    }
    #[inline]
    pub fn procedure_rid(&self) -> &conjure_object::ResourceIdentifier {
        &self.procedure_rid
    }
    #[inline]
    pub fn step_id(&self) -> &str {
        &*self.step_id
    }
}
